m = 0.4
l = 0.15
b = 0.005
g = 10
k = 0.01

a1 = b/m/l/l
a0 = g/l
b0 = k/m/l/l

K = 1
T = 0.1
phi0 = pi/4

u0 = 42.4115

% excitation signal
u_ex_var = 5

%%
% arx model
sim("IdentifikaceNelinearnichParametru.slx")
N = min([length(y_sim.Data) length(u_sim.Data)])

clear y u Phi Theta
y = y_sim.Data(1:N)
u = u_sim.Data(1:N)

for n = 3:N
    Phi(n,:) = [-y(n-1) -y(n-2) u(n-1) u(n-2)];
end

%Theta = inv(Phi'*Phi)*Phi'*y
Theta = Phi\y %least squares
%% Validation
% delta = ((-a1+sqrt(a1^2-4*a0*cos(phi0)))*T)/2
% c2 = a0*cos(phi0)-a1^2/4
% B1 = -2*c2*b0*exp(delta)+2*c2*b0
% B0 = -2*c2*b0*exp(delta)+2*c2*b0*exp(-T*a1)
% A2 = 2*c2*a0*cos(phi0)
% A1 = -2*c2*a0*cos(phi0)*(exp(delta)+exp(-delta))
% A0 = 2*c2*a0*cos(phi0)

Theta0 = [A1/A2 A0/A2 B1/A2 B0/A2]'
Theta