clear all
clear 
load data03.mat

T = 0.02
y_offset_true = 40
y_offset = 40
% excitation signal
u_ts = [(1:length(u))'*T u];

Theta0 = [1.9945 -0.007 -0.99 0.0001]
sim('IdentValidation.slx')

y = y_sim.Data(:,1);


start = 2;
stop = length(y);

[ydot, yddot] = num_derivatives_from_location_data(y,T,start,stop);

%fft_viz(y,T)

order_fir = 100;       % FIR filter order
Fp  = 1; % Cutoff frequency (Hz)
Fs  = 1/T;       
h = fir1(order_fir,Fp*2*T);  % Calculated FIR filter

[yf, ydotf, yddotf, start_after_filt] = fir_filter(y, ydot, yddot, h, order_fir, start, stop);

[Theta yhat] = identify(yf,ydotf,yddotf, u, y_offset, start_after_filt);
   
Theta0

Theta