clear all
close all
load('PI_P')
Theta = [0.4554  %Identifikovane parametry
        3.2503
        13.3097]
% 130 deg
y_lin = 130
A = [-Theta(1) -Theta(2)*cos(y_lin*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0
F130 = tf(ss(A,B,C,D))
Ts = 0.02;
Fd = c2d(F130,Ts,'zoh')
plant_ss130 = ss(Fd)

% 50 deg
y_lin = 50
A = [-Theta(1) -Theta(2)*cos(y_lin*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0
F50 = tf(ss(A,B,C,D))
Ts = 0.02;
Fd = c2d(F50,Ts,'zoh')
plant_ss50 = ss(Fd)


y_lin = 90
A = [-Theta(1) -Theta(2)*cos(y_lin*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0
F = tf(ss(A,B,C,D))
Ts = 0.02;
Fd = c2d(F,Ts,'zoh')
plant_ss = ss(Fd)

%y_offset = 40


C1d = c2d(C1,Ts,'zoh')
C2d = c2d(C2,Ts,'zoh')
s = tf('s')
u0 = Theta(2)*sin((y_lin)*pi/180)/Theta(3) % ustaleny vstup pro y_lin

t = 0:Ts:100

w0 = 0.5
z0 = -0.1
z1 = 0.1
z2 = 0.1

% p = tf('p')
% s = 1/p

%% Low-pass filter for input disturbance rejection
Fp = 1
wp = Fp*2*pi
Ts_lp = 1/wp

%%
figure
subplot(2,1,1)
hold on
plot(out.simout1.time, out.simout1.Data(:,1))
plot(out.simout1.time, out.simout1.Data(:,2))
title('Cascade control time response','Interpreter','Latex')
xlabel('Time [s]','Interpreter','Latex')
ylabel('Output $y$','Interpreter','Latex')
subplot(2,1,2)
plot(out.simout1.time, out.simout1.Data(:,3))
title('Input disturbance present','Interpreter','Latex')
ylabel('Input disturbance $z$','Interpreter','Latex')
xlabel('Time [s]','Interpreter','Latex')
