clear
Theta = [0.4554  
        3.2503
        13.3097]
A = [-Theta(1) -Theta(2)*cos(90*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0
linSys90 = tf(ss(A,B,C,D))

A = [-Theta(1) -Theta(2)*cos(50*pi/180);
    1   0];
linSys50 = tf(ss(A,B,C,D))

A = [-Theta(1) -Theta(2)*cos(130*pi/180);
    1   0];
linSys130 = tf(ss(A,B,C,D))

s = tf('s')



%% Overeni linearizace na nelinearnim systemu

load data03.mat

y_offset = 0
uplus = 0 %Vychyleni z ustaleneho vstupu
u0 = Theta(2)*sin(90*pi/180)/Theta(3)
u = u0+uplus
ic = 1;
opts = odeset('RelTol',1e-2,'AbsTol',1e-4);

%yddot + ydot + sin(y + offset) = u


tspan = [0 10];
[tode,yode] = ode45(@(tode,yode) pendulumEq(tode, yode, u, Theta, y_offset), tspan, [90*pi/180 0]);

figure
plot(tode,yode)


figure
lsim(linSys90,uplus*ones(1,101),0:0.1:10)
