clear all
close all
y_lin = 80
Theta = [0.4554  %Identifikovane parametry
        3.2503
        13.3097]
A = [-Theta(1) -Theta(2)*cos(y_lin*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0

% A = [0 1;0 0]
% B = [0;1]
% C = [1 0]
F = tf(ss(A,B,C,D))
Ts = 0.02;
Fd = c2d(F,Ts,'zoh')
plant_ss = ss(Fd)

%y_offset = 40

u0 = Theta(2)*sin((y_lin)*pi/180)/Theta(3) % ustaleny vstup pro y_lin

t = 0:Ts:100

%%
Ar = [A,B;[0 0 0]]
Br = [B;0]
Cr = [C 0]

L = place(Ar',Cr', 1*[-10 -15 -20] )'

Frek = Ar-L*Cr
eig(Frek)
%%
Ard = [plant_ss.A,plant_ss.B;[0 0 1]]
Brd = [plant_ss.B; 0]
Crd = [plant_ss.C 0]

Ld = acker(Ard',Crd', 1*[0 0 0] )'

Frekd = Ard-Ld*Crd
eig(Frekd)